--2)procedure stockee qui permet d’afficher la moyenne de l’age des adherents inscrits pour chaque activite de l’association.

set serveroutput on

create or replace procedure age_moyen as

	cursor les_ages is
	
		select intitule, avg((sysdate-datenais)/365) moyenne_age
		from activite act, adherent adh, participe p
		where p.numadh=adh.numadh
		and p.numact=act.numact
		and p.anneeparticipe=to_number(to_char(sysdate,'YYYY'))
		group by intitule
		order by intitule;

/*
creation d'un curseur qui recupere l'age moyen participants actuellement insrits pour chaque activite.
Pour avoir l age moyen des participants a l activite depuis sa creation, il suffit de supprimer la ligne "and p.anneeparticipe=to_number(to_char(sysdate,'YYYY'))".
*/



une_activite les_ages%rowtype;

begin

	open les_ages;
	--on ouvre le curseur pour s'en servir
	loop

		fetch les_ages into une_activite;
		exit when les_ages%notfound;

/*
On place la ligne du curseur dans une variable, et on quitte la boucle des qu'il n'y a plus d'adherent dans le curseur
*/
dbms_output.put_line(une_activite.intitule||' : '||ROUND(une_activite.moyenne_age,3)||' ans de moyenne d''age en '||to_char(sysdate,'YYYY')||'.');
		--affichage de l'age moyen de chaque activite, arrondi a 3 decimales apres la virgule, et de l annee concernee.
	end loop;

close les_ages;
--on ferme le curseur

end;
/



